% MWC simulation script for thales works : Modified 160425%
% Jehyuk Jang


%% Determined parameters
% Signal parameters
fnyq=fmax*2;    Tnyq = 1/fnyq;     % Fixed; Restrict the maximal frequency of input signals; fmax=fnyq/2
% System parameters
fp=fmax*2/M;    Tp=1/fp;
qs=floor(fs_max/fp);
fs=fp*qs;
k=qs*k_; % Fixed; The number of analog measurement vectors; Whole sampling time(observation time) = k*Ts = k_*Tp
qf=floor(qs/2)*2+1;
L=M+qf-1;    % Fixed
L0=(L-1)/2; % Fixed
M0=(M-1)/2; % Fixed
Ts=1/fs;
To=k*Ts;
fr=1/To;
f_LPF=fs*qf/qs;



Tslot=k*Ts;
fr=1/Tslot;


observationTime = Tslot*numTimeSlots;

B=fp*0.5;



% Simulation parameters
Res=qs*ResInt;        % Fixed; Res should be q*(integer), where (integer) is greater than L/M -> res<1/fnyq; Time grid interval; Higher Res -> more dense grid
res=1/fp/M/Res; % Fixed
if mod(qs,2)==0 && NonIdealFilter==true
    JSM2=true;
else
    JSM2=false;
end

% JSM2=false;



%% Generating input signals (Pulse, CW, Pulse Doppler(PD))
% Generate dense time & frequency grids
t_axis=0:res:k*Ts*numTimeSlots-res;
f_axis=-1/res/2: 1/t_axis(end):  1/res/2+1/t_axis(end)-1/t_axis(end);

% Generate input signal & noise
x = zeros(size(t_axis));
PWLowerLimit=max(50*10^-9,2/B);
% PWUpperLimit=min(20*10^-3,To/2);
PWUpperLimit=min(20*10^-3,observationTime/numTimeSlots/2);

% PW=5*(PWLowerLimit+rand(1,N/2)*(PWUpperLimit-PWLowerLimit));        % random pulsewidths
PW=0.5*PWLowerLimit+rand(1,N/2)*(PWUpperLimit-PWLowerLimit); 



MaxBW=2/PWLowerLimit;
% MinCarrDist=4*MaxBW;
MinCarrDist=fp*2.5;


while 1
    fci = fmin+B/2+rand(1,(N/2))*(fnyq/2-fmin-B);      % random carriers within [fmin+B/2, fmax-B/2]
    if numel(find(abs(diff(sort(fci)))<MinCarrDist))==0
        break;
    end
end




Ti=(max(t_axis)-PW).*rand(1,N/2)+PW/2;                         % random pulse arrival time
%AMP=1+rand(1,N/2)*(10^(11/2)-1);                        % random amplitudes
AMP=ones(1,N/2);
if strcmp(RADAR,'Pulse')
    DC=0.05*(10^-2)+0.05*(10^-2)*rand(1,N/2);     % Duty cycle (5~10%)
    PRI=PW./DC;
    
    
    
    for n=1:(N/2)
       %han_win = hann(length(1:ceil(PW(n)/res)))'; 
       han_win=hann(length(x))';
        
       OneLength=ceil(PW(n)/res);
       PurePulseShape=[zeros(1, floor((length(t_axis)-OneLength)/2)) ones(1,OneLength) zeros(1, ceil((length(t_axis)-OneLength)/2))];
       temp=fft(PurePulseShape);
       BandLimitingLPFindices=ceil(B*t_axis(end));
        BandLimitingLPFindices_right=ceil(BandLimitingLPFindices/2);
        BandLimitingLPFindices_left=BandLimitingLPFindices-BandLimitingLPFindices_right;
      
        BandLimitingLPF=ifftshift([zeros(1, ceil((length(t_axis)-BandLimitingLPFindices)/2)) hann(BandLimitingLPFindices)' zeros(1, floor((length(t_axis)-BandLimitingLPFindices)/2))]);
        %BandLimitingLPF=[ones(1,BandLimitingLPFindices_right) zeros(1, length(t_axis)-BandLimitingLPFindices) ones(1, BandLimitingLPFindices_left)];
        
%                 BandLimitingLPF=[ones(1,LPFindices_right) zeros(1, length(t_axis)-LPFindices) ones(1, LPFindices_left)];

        
       BandLimitedPulseShape=real(ifft(fft(PurePulseShape).*BandLimitingLPF));
%        BandLimitedPulseShape=real(ifft(fft(PurePulseShape).*BandLimitingLPF.*han_win));
       
       PulseShape=cos(2*pi*fci(n)*t_axis).*BandLimitedPulseShape;
       % PulseShape=cos(2*pi*fci(n)*(t_axis(1:ceil(PW(n)/res))));
        
      



        
        rightNPulses=floor((max(t_axis)-Ti(n))/PRI(n));
        leftNPulses=floor(Ti(n)/PRI(n));
        Pulseindices=round((Ti(n)+PRI(n)*(-leftNPulses:rightNPulses))/res)+1;
        PulseLoc=zeros(size(t_axis));
        PulseLoc(Pulseindices)=1;
        xn=conv(PulseLoc,PulseShape,'same');
        
        
     
        
%          Wn=[fci(n)-fp/2, fci(n)+fp/2];
%         
%         [b a]=butter(5, Wn/f_axis(end), 'bandpass');
%         xn=filter(b,a, xn);
%         
%         
        x = x+AMP(n)*xn;
    
    
       
        
        
    end
          
   
    
    
elseif strcmp(RADAR,'PD')
    DC=30*(10^-2)+10*(10^-2)*rand(1,N/2);     % Duty cycle (30~40%)
    PRI=PW./DC;
    for n=1:(N/2)
        PulseShape=ones(1,length(1:ceil(PW(n)/res)));
        rightNPulses=floor((max(t_axis)-Ti(n))/PRI(n));
        leftNPulses=floor(Ti(n)/PRI(n));
        Pulseindices=round((Ti(n)+PRI(n)*(-leftNPulses:rightNPulses))/res)+1;
        PulseLoc=zeros(size(t_axis));
        PulseLoc(Pulseindices)=1;
        xn=conv(PulseLoc,PulseShape,'same');
        x = x+AMP(n)*xn.*cos(2*pi*fci(n)*(t_axis-Ti(n)));
    end
elseif strcmp(RADAR,'CW')
    DC=0.5;     % Duty cycle (50%)
    PRI=PW./DC;
    for n=1:(N/2)
        fiIni=fci(n);
        FreqRampShape=linspace(0,B,ceil(PW(n)/res));
        rightNRamps=floor((max(t_axis)-Ti(n))/PRI(n));
        leftNRamps=floor(Ti(n)/PRI(n));
        Rampindices=round((Ti(n)+PRI(n)*(-leftNRamps:rightNRamps))/res)+1;
        RampLoc=zeros(size(t_axis));
        RampLoc(Rampindices)=1;
        FreqVar=conv(RampLoc,FreqRampShape,'same')+fiIni;
        x = x+AMP(n)*cos(2*pi*FreqVar.*(t_axis-Ti(n)));
    end
        
elseif strcmp(RADAR,'test')
    for n=1:(N/2)
        x = x+sinc(B*(t_axis-t_axis(end)/2)) .* cos(2*pi*fci(n)*(t_axis-t_axis(end)/2));
    end
    han_win = hann(length(x))';             % Add window
    x = x.*han_win;
else
    error('invalid radar type');
end
SNR_val = 10^(SNR/10);
n = normrnd(0,1,1,length(t_axis));
NoiseEnergy = norm(n)^2;


SignalEnergy = norm(x)^2;

CurrentSNR = SignalEnergy/NoiseEnergy;
n=n*sqrt(CurrentSNR/SNR_val);


%% Time slot method's start line




Xa=x;
Na=n;
time_axis=t_axis;

Zta=zeros(M,k_);
Zta1=zeros(M,k_);
Zta2=zeros(M,k_);
Zta3=zeros(M,k_);
Zt1=[];
Zt2=[];
Zt3=[];
Zt=[];

SucFlag=0;





Zka=zeros(M,numTimeSlots*k_+kk_);
Zka1=zeros(M,numTimeSlots*k_+kk_);
Zka2=zeros(M,numTimeSlots*k_+kk_);
Zka3=zeros(M,numTimeSlots*k_+kk_);


for nTimeSlot = 1 : numTimeSlots

RRecSuppSorted1=[];
RRecSuppSorted2=[];
RRecSuppSorted3=[];
    
    
    
    
% t_axis=time_axis((nTimeSlot-1)*(length(time_axis)/numTimeSlots)+1 : (nTimeSlot)*(length(time_axis)/numTimeSlots));

t_axis=time_axis(1:(length(time_axis)/numTimeSlots));



x=Xa((nTimeSlot-1)*(length(time_axis)/numTimeSlots)+1 : (nTimeSlot)*(length(time_axis)/numTimeSlots));

n=Na((nTimeSlot-1)*(length(time_axis)/numTimeSlots)+1 : (nTimeSlot)*(length(time_axis)/numTimeSlots));















%% Generating mixing signals
% Generate mixing sign patterns(sequences)
if RPF==0
    %SignPatterns=randsrc(m,M);
elseif RPF==1
    %seq=LFSR(M, 'legendre');
    seq=randsrc(1,M);
    seq=reshape(seq,1,length(seq));
    SignBar=zeros(M,M);
    for i=1:M
        SignBar(i,:)=circshift(seq, [0 i-1]);
    end
    R_om=zeros(m,M);
    OneLoc=randperm(M,m);
    for i=1:m
        R_om(i,OneLoc(i))=1;
    end
%     SignPatterns=R_om*SignBar;
elseif RPF==2
    seq=LFSR(M, 'maximum');
    seq=reshape(seq,1,length(seq));
    SignBar=zeros(M,M);
    for i=1:4
        SignBar(i,:)=circshift(seq, [0 i-1]);
    end
%     R_om=zeros(m,M);
%     OneLoc=randperm(7,m);
%     for i=1:m
%         R_om(i,OneLoc(i))=1;
%     end
    %SignPatterns=R_om*SignBar;
    SignPatterns=SignBar;
elseif RPF==3
    SignBar=zeros(4,M);
    for i=1:4
        SignBar(i,:)=circshift(seq, [0 i-1]);
    end
    SignPatterns=mod(R_c*SignBar,2)*2-1;
end

% Generate mixing signals
p=zeros(m, length(t_axis));
shape=ones(1, round(Tp/M/res)); %Tp/M/res = Res
for i=1:m
    temp=zeros(1,length(t_axis)/k_);
    l=0:M-1;
    tempIndices=round((l+1)*Tp/M/res)-(ceil(Tp/M/res/2)-1);
    temp(tempIndices)=SignPatterns(i,mod(l,M)+1);
    temp2=conv(temp,shape,'same');
    p(i,:)=repmat(temp2,1,k_);
end

%% Mixing
s1=zeros(m, length(t_axis));
for i=1:m
    s1(i,:)=(x+n).*p(i,:);
end

%% Lowpass filtering
if NonIdealFilter==false
    LPFindices=ceil(f_LPF*t_axis(end));
    LPFindices_right=ceil(LPFindices/2);
    LPFindices_left=LPFindices-LPFindices_right;
    Afilter=[ones(1,LPFindices_right) zeros(1, length(t_axis)-LPFindices) ones(1, LPFindices_left)];
    Afilter=fftshift(Afilter);
else
    % Afilter=[normrnd(0,1,1,LPFindices_right)+sqrt(-1)*normrnd(0,1,1,LPFindices_right) zeros(1, length(t_axis)-LPFindices) normrnd(0,1,1, LPFindices_left)+sqrt(-1)*normrnd(0,1,1, LPFindices_left)];
    % Afilter_Imp=real(ifft(Afilter));
    % Afilter=fftshift(fft(Afilter_Imp));
    
    AImpulse=zeros(1,length(x));
    AImpulse(1)=1;
    Afilter_Imp=fftfilt(FNum,AImpulse);
    Afilter_Imp=circshift(Afilter_Imp, [0 -(length(FNum)-1)/2]);
    Afilter=fftshift(fft(Afilter_Imp));
end

s2=zeros(m, length(t_axis));
for i=1:m
    temp=s1(i,:);
    DFTtemp=fftshift(fft(temp));
    DFTout=ifftshift(DFTtemp.*Afilter);
    s2(i,:)=real(ifft(DFTout));
end

%% Sampling
% Find analog outputs
SampIntervIndices=round(Ts/res);    % Ts/res is integer in itself
SampIndices=(0:k-1)*SampIntervIndices+1;
Y=zeros(m,k);
for i=1:m
    ChOut=s2(i,:);
    Y(i,:)=ChOut(SampIndices);
end

%% Digital signal processing
% Calculate Fourier coefficients of the mixing sequences (Sensing matrix
% for the analog outputs)

S = SignPatterns;
theta = exp(-1i*2*pi/M);
F = theta.^([0:M-1]'*[L0:-1:-L0]);
np = L0:-1:1;
nn = -1:-1:-L0;
R=Res;  % Relationship of the resolution factors in my code and in Mishalli's code
dn = [   (1-theta.^np)./(1-theta.^(np/R))/(M*R)      1/M    (1-theta.^nn)./(1-theta.^(nn/R))/(M*R)];
D = diag(dn);
A = S*F*D;
A = conj(A);  

%%Zero padding



Y=[Y, zeros(size(Y,1), qs*kk_  ) ];

k_=k_+kk_;
k=qs*k_;




TempResp=ifftshift(Afilter);
DCom_Filter=1./fftshift([TempResp(1:ceil(k/2)) TempResp(end-floor(k/2)+1:end)]);
if JSM2==true
    Filter_Effective=fftshift([TempResp(1:ceil(qf*k_/2)) TempResp(end-floor(qf*k_/2)+1:end)]);
    Filter_Aliased2=Filter_Effective(1:k_);
    Filter_Aliased1=Filter_Effective(end-k_+1:end);
    Alpha=[ones(1, floor(k_/2)) Filter_Aliased1(end-ceil(k_/2)+1:end)./Filter_Aliased2(end-ceil(k_/2)+1:end)];
    Beta=[Filter_Aliased2(1:floor(k_/2))./Filter_Aliased1(1:floor(k_/2)) ones(1, ceil(k_/2))];
end

if qs>1  % Additional DSP for q>1
    if qs==qf
        qp=(qs-1)/2;
        % Construct digital outputs for q>1
        Yd=[];
        for i=1:m
            TempAO=double(Y(i,:));
            TempAOf=fftshift(fft(TempAO));
%             TempAOf=TempAOf.*DCom_Filter;
            for ii=0:qs-1
                %Yd=[Yd;ifft(ifftshift(double(TempAOf(ii*k_+1:(ii+1)*k_))))];
                Yd=[Yd;double(TempAOf(ii*k_+1:(ii+1)*k_))];
            end
        end
        
        
       
        
        % Construct digital sensing matrix for q>1
        C=zeros(m*qs,M);
        for i=1:m
            TempA=A(i,:);
            for ii=-qp:qp
                C(i*qs-qp+ii,:)=TempA((L0+1)-M0+ii:(L0+1)+M0+ii);
            end
        end
        Cset=C;
        
    else    % qs~=qf
         % Construct digital outputs for qs>1 and qs~=qf
         Yd=[];
        for i=1:m
            TempAO=double(Y(i,:));
            TempAOf=fftshift(fft(TempAO)); 
            TempAOf=TempAOf.*DCom_Filter;
            Yd=[Yd;double(TempAOf(end-floor(k_/2)+1:end)) double(TempAOf(1:ceil(k_/2)))];
            %Yd=[Yd;ifft(ifftshift([double(TempAOf(end-ceil(k_/2)+1:end)) double(TempAOf(1:floor(k_/2)))]))];
            for ii=0:qs-2
                Yd=[Yd;double(TempAOf(ceil(k_/2)+ii*k_+1:ceil(k_/2)+(ii+1)*k_))];
                %Yd=[Yd;ifft(ifftshift(double(TempAOf(floor(k_/2)+ii*k_+1:floor(k_/2)+(ii+1)*k_))))];
            end
        end
        
        % Construct digital sensing matrix for q>1
        if JSM2==true
            Cset=cell(1,k_);
            for Freq=1:k_
                C=zeros(m*qs,M);
                qp=qs/2;
                for i=1:m
                    TempA=A(i,:);
                    for ii=-qp:qp-1
                        if ii==-qp
                            C(i*qs-qp+ii+1,:)=Beta(Freq)*TempA((L0+1)-M0+ii:(L0+1)+M0+ii)+Alpha(Freq)*conj(fliplr(TempA((L0+1)-M0+ii:(L0+1)+M0+ii)));
                        else
                            C(i*qs-qp+ii+1,:)=TempA((L0+1)-M0+ii:(L0+1)+M0+ii);
                        end
                    end
                end
                Cset(Freq)={C};
            end
        else
            C=zeros(m*qs,M);
            qp=qs/2;
            for i=1:m
                TempA=A(i,:);
                for ii=-qp:qp-1
                    if ii==-qp
                        C(i*qs-qp+ii+1,:)=TempA((L0+1)-M0+ii:(L0+1)+M0+ii)+conj(fliplr(TempA((L0+1)-M0+ii:(L0+1)+M0+ii)));
                    else
                        C(i*qs-qp+ii+1,:)=TempA((L0+1)-M0+ii:(L0+1)+M0+ii);
                    end
                end
            end
            Cset=C;
        end
    end
else
    Yd=fftshift(fft(Y.').',2);
    Cset=A;
end

Varphi=floor((fmin+0.5*fp)/fp);
Varphi_neg=max(Varphi-1,0);
NumUnusedRowIndices=Varphi+Varphi_neg;
UnusedRowIndices=linspace(-Varphi_neg,Varphi_neg,NumUnusedRowIndices)+M0+1;
UsedRowIndices=setdiff([1:M],UnusedRowIndices);
if JSM2==true
    Cset_ind=cell(size(Cset));
    for Freq=1:k_
        tempC=Cset{Freq};
        Cset_ind(Freq)={tempC(:,UsedRowIndices)};
    end
else
    Cset_ind=Cset(:,UsedRowIndices);
end



%% C   © ֱ


if half_sampling==true
    
    
    Cset_ind=Cset_ind(:,1: (M-NumUnusedRowIndices)/2 );
   
    
    
end




k_=k_-kk_;
k=qs*k_;





% Calculate original support set (Eldar's code)
Sorig = [];
Starts = ceil((fci-B/2)/fp-0.5+M0+1);
Ends = ceil((fci+B/2)/fp-0.5+M0+1);
for i=1:(N/2)
    Sorig = union(Sorig,  Starts(i):Ends(i));
end
Sorig = union(Sorig, M+1-Sorig);
Sorig = sort(Sorig);
Sorig =reshape(Sorig,1,length(Sorig));

if PCA==true
    Q=Yd*Yd';
    [V1, D1]=eig(Q);
    d1=diag(D1);
    [trash, ind]=sort(abs(d1),'descend');
    V=V1(:,ind(1:OMP_N*2))*diag(d1(ind(1:OMP_N*2)));
    Yomp=V;
else
    Yomp=Yd;
end

%% To 

% To=Ts*qs*(k_+kk_);

[trash, RecSupp]=RunOMP_Unnormalized(Yomp, Cset_ind, OMP_N,  0, SymmetricSupport, JSM2, half_sampling, OMP_SubSampling,To,B,k_);
%floor(m*qs/2)
RecSuppSorted = sort(unique(RecSupp));

if half_sampling==true
    halfSup=sort((M-NumUnusedRowIndices+1)-RecSuppSorted);
    RecSuppSorted=[RecSuppSorted, halfSup];
             
end



if numel(UnusedRowIndices)==0
    RRecSuppSorted=RecSuppSorted;
else
RecSuppLow=RecSuppSorted(RecSuppSorted<min(UnusedRowIndices));
RecSuppHigh=RecSuppSorted(RecSuppSorted>=min(UnusedRowIndices))+NumUnusedRowIndices;
RRecSuppSorted=unique([RecSuppLow RecSuppHigh]);
end




if is_contained(Sorig,RRecSuppSorted)
    %&& (rank(C(:,RRecSuppSorted)) == length(RRecSuppSorted))
    Sucflag=1;
    %fprintf('Successful support recovery\n');
else
    Sucflag=0;
    %fprintf('Failed support recovery\n');
end
SucFlag=SucFlag+Sucflag;


%% Reconstruct the input singal

    C_S = Cset(:,RRecSuppSorted);  
    hat_zn = pinv(C_S)*Yd;  % inverting A_S



%% Spectrum slice optimization      
zn=zeros(size(C,2),size(Yd,2));

zn(RRecSuppSorted,:)=flipud(hat_zn);


for i=1:M
    
    Zka(i,k_*(nTimeSlot-1)+1 : k_*(nTimeSlot)+kk_ ) = [Zka(i, k_*(nTimeSlot-1)+1 : k_*(nTimeSlot-1)+kk_ ), zeros(1,k_)   ] + ifft(ifftshift(zn(i,:)));    
end



end

% ZZaf=zeros(1,numTimeSlots*k_*M+kk_);
% Zka=fftshift(fft(Zka.').',2);
% 
% for i=1:M
%     if i==1
%     ZZaf( (i-1)*k_+1 : i*k_ )=Zka(1,1:k_);    
%     else
%     ZZaf( (i-1)*k_+1 : i*k_ )=[Zka(i-1,k_+1:k_+kk_), zeros(1,k_-kk_) ]+Zka(i,1:k_);
%     end
% end
% 
% ZZaaf=ZZaf(1:numTimeSlots*k_*M);
% 
% 
% zfv=M/qs*double(ZZaaf);
% ztv=ifft(ifftshift(zfv));
% ztvr=interpft(ztv,length(Xa));
% x_rec = reshape(real(ztvr),1,length(ztvr));
% MSE=norm(Xa-x_rec)^2/norm(Xa)^2;

%

Zt=Zka(:,1:numTimeSlots*k_);
zn=fftshift(fft(Zt.').',2);
zf=M/qs*double(zn);    
zfv=reshape(zf.',numel(zf),1);
ztv=ifft(ifftshift(zfv));
ztvr=interpft(ztv,length(Xa));
zfvr=fftshift(fft(ztvr));


x_rec = reshape(real(ztvr),1,length(ztvr));
MSE=norm(Xa-x_rec)^2/norm(Xa)^2;





%
% Zt=Zka(:,1:numTimeSlots*k_);
% 
% 
% % zn=ifft(ifftshift(Zt,2))
% % zt=M/qs*double(zn);   
% % ztv=reshape(zt.',numel(zt),1);
% % ztvr=interpft(ztv,length(Xa));
% % 
% 
% 
% zn=Zt;
% 
% 
% zf=M/qs*double(zn);    
% zfv=reshape(zf.',numel(zf),1);
% ztv=ifft(zfv);
% % ztv=ifft(ifftshift(zfv));
% ztvr=interpft(ztv,length(Xa));
% zfvr=fftshift(fft(ztvr));
% x_rec = reshape(real(ztvr),1,length(ztvr));
% 
% 
% MSE=norm(Xa-x_rec)^2/norm(Xa)^2;

% 
% MSEE=0;
% MSE=0;
% 
% MSEK=zeros(1,length(Xa));
% 
% for i=1 : length(Xa)
% %     MSE(i) = abs(Xa(i)-x_rec(i)) /(abs(Xa(i))) ;
%     
%     MSEK(i) = abs(Xa(i)-x_rec(i)) ;
%     
% end
% 
% Epsil=10;
% 
% for j=1:numTimeSlots-1
%     
% MSEE1=MSEK(j*round(length(Xa)/numTimeSlots)-Epsil:j*round(length(Xa)/numTimeSlots)+Epsil );
% 
% MSEE=MSEE+MSEE1;
% 
% end
% 
% MSEE=MSEE/(numTimeSlots-1);
% 
% for i=1:length(MSEE)
%    MSE1=MSEE(i);
%    MSE=MSE+MSE1;
%    
% end
% 
% MSE=MSE/length(MSEE);
   


% %% Estimation of PDW
% zf_opt=M/qs*flipud(hat_zn);
% 
% Centered_Supp=RRecSuppSorted-(M+1)/2;
% Centered_Pos_Supp=Centered_Supp(Centered_Supp>=0);
% f_slice=-fp/2:fr:-fp/2+fr*(k_-1); f_slice=f_slice.';
% f_slice_Pos_full=repmat(f_slice,1,length(Centered_Pos_Supp));
% CenterFreq=repmat(Centered_Pos_Supp*fp,k_,1);
% f_optimized_Pos_axis=f_slice_Pos_full+CenterFreq;
% f_optimized_Pos_axis=reshape(f_optimized_Pos_axis,1,numel(Centered_Pos_Supp)*k_);
% 
% zf_Pos=zf_opt(floor(length(RRecSuppSorted)/2)+1:length(RRecSuppSorted),:);
% zfv_Pos=reshape(zf_Pos.',numel(zf_Pos),1);
% 
% 
% MinBW=2/PWUpperLimit;
% MinIBDist=MinCarrDist/2;
% Threshold=sqrt(sum(abs(zfv_Pos).^2)/length(zfv_Pos));
% % [val,ind]=sort(abs(zfv_Pos),'descend');
% % PeakIndices=sort(ind(val>Threshold),'ascend');
% % PeakDists=diff([0; PeakIndices]);
% % PeakIndices(abs(PeakDists
% EnvelopeMask=zeros(1,length(zfv_Pos));
% EnvelopeMask(abs(zfv_Pos)>Threshold)=1;
% DiffEnvel=diff([0 EnvelopeMask 0]);
% StartIndices=find(DiffEnvel==1);
% EndIndices=find(DiffEnvel==-1);
% EndIndices(EndIndices>length(zfv_Pos))=length(zfv_Pos);
% Indices_ShortDist=find(StartIndices(2:end)-EndIndices(1:end-1)<MinIBDist/fr);
% UnifiedStartIndices=StartIndices(setdiff(1:length(StartIndices),Indices_ShortDist+1));
% UnifiedEndIndices=EndIndices(setdiff(1:length(EndIndices),Indices_ShortDist));
% Indices_NarrowImp=find(UnifiedEndIndices-UnifiedStartIndices<MinBW/fr);
% RefinedStartIndices=UnifiedStartIndices(setdiff(1:length(UnifiedStartIndices),Indices_NarrowImp));
% RefinedEndIndices=UnifiedEndIndices(setdiff(1:length(UnifiedEndIndices),Indices_NarrowImp));
% CenterIndices=round((RefinedStartIndices+RefinedEndIndices)/2);
% % BorderIndices=PeakIndices(1:end-1)+round(diff(PeakIndices)/2);
% % DivideStartIndices=[1 BorderIndices];
% % DivideEndIndices=[BorderIndices-1 length(zfv_Pos)];
% %---
% % DivideStartIndices=CenterIndices-ceil(MinCarrDist/2/fr);DivideStartIndices(1)=max(DivideStartIndices(1),1);
% % DivideEndIndices=CenterIndices+ceil(MinCarrDist/2/fr);DivideEndIndices(end)=min(DivideEndIndices(end),length(zfv_Pos));
% N_cap=length(RefinedStartIndices)*2;
% 
% DividedPositiveSpectra=cell(2,N_cap/2);
% fci_cap=zeros(1,N_cap/2);
% for i=1:N_cap/2
%     DividedPositiveSpectra(1,i)={f_optimized_Pos_axis(RefinedStartIndices(i):RefinedEndIndices(i))};
%     DividedPositiveSpectra(2,i)={zfv_Pos(RefinedStartIndices(i):RefinedEndIndices(i))};
%     [a, b]=max(abs(DividedPositiveSpectra{2,i}));
%     DivPos_f_axis=DividedPositiveSpectra{1,i};
%     fci_cap(i)=DivPos_f_axis(b);
% end
% 
% if N_cap>N
%     NFalse=NFalse+1;
%     FcError=0;
% elseif N_cap<N
%     NMiss=NMiss+1;
%     FcError=0;
% else
%     FcError=sum(abs(sort(fci)-sort(fci_cap))./sort(fci))/(N/2);
% end



