clear;
hold on
% close all
f_NYQ=4e9;
qs=9;


kappa=6;
R_max=10;
R_axis=(1:R_max);
fp=31.49e6;
B=0.6*fp;
M=floor(ceil(f_NYQ/fp)/2);
ps_MCDR=B/fp;
if ps_MCDR>1
    error('Too large B compared to fp')
end

W_bpf=4*qs*fp;

CondProbs=zeros(2*R_max,R_max); %Prob(K=w|R=x)
for w=1:2*R_max
    for x=1:R_max
        Marginal=0;
        for y=0:x
            Marginal=Marginal+nchoosek(x,y)*ps_MCDR^y*(1-ps_MCDR)^(x-y)/SUM_PERMS(w,x,y,M);
        end
        CondProbs(w,x)=Marginal;
    end
end
PSuc_R_MCDR=sum(CondProbs(1:kappa,:),1)

if W_bpf>f_NYQ/2
    error('Too large W_bpf')
end
PSuc_R_RSSR=(2*(W_bpf-B)/(f_NYQ-2*B)).^R_axis

plot(R_axis,PSuc_R_MCDR)
hold on
plot(R_axis,PSuc_R_RSSR,'r')
legend('MCDR', 'RSSR')
ylabel('Probability of successful sampling')
xlabel('The number of received radar signals (R)')
xlim([1 R_max])
ylim([0 1])
grid on
% title(strcat('\kappa_{MCDR}=',num2str(kappa), ', f_{max}=', num2str(f_NYQ/2/10^9),' [GHz]',', B=', num2str(B/10^6), ' [MHz]',', f_p=',num2str(fp/10^6),' [MHz]',', W_{BPF}=', num2str(W_bpf/10^9),' [GHz]'))