% clear;

hold on
% close all
f_NYQ=4e9;

m=4;
q=7;
fp=31.49e6;
fs=q*fp;
To=3.269*10^-6; % k=101 3.2067 or k=68 for To=2.169e-6
floor(B*To)

%RMPI parameter
System_switch=[1,2]; % 1 : MWC, 2: RMPI


fbs=m*fs;
N_block=floor(fnyq/fbs);
ps_RMPI=B*To-floor(B*To);



R_max=10;
R_axis=(1:R_max);
fp=31.49e6;

B=0.1*fp;

M=floor(ceil(f_NYQ/fp)/2);
ps_MCDR=B/fp;
if ps_MCDR>1
    error('Too large B compared to fp')
end

W_bpf=m*q*fp;


x=1:R_max;




%%

kappa=2*4;
kappa_rmpi=N_block*kappa;

mu=0:0.1:10;



%


for System_switch=[1 2]
    
Mk=zeros(length(mu),length(x));
mu_index=0;

for mu=0:0.1:10         % if reparametering, i should remanage the following parameter (mu_1)
mu_index=mu_index+1;


for x=1:R_max
   
    Mk1=0;
    
    for k=x:2*x 
        
if System_switch==1
       Mk1=Mk1 + exp(mu*k)*nchoosek(x,k-x)*ps_MCDR^(k-x)*(1-ps_MCDR)^(x-(k-x)); % MWC
else
           Mk1=Mk1 + exp(mu*k)*nchoosek(x,k-x)*ps_RMPI^(k-x)*(1-ps_RMPI)^(x-(k-x)); % RMPI
end
    end
   Mk(mu_index,x)=Mk1;
    
end

end


% find optimal mu

muu=zeros(1,R_max);
mu_1=(0:0.1:10)';


for x=1:R_max
      
    if System_switch==1
[a, b]= min( log(Mk(:,x))-mu_1*kappa ) ; %a= value , b=location
    else
        [a, b]= min( log(Mk(:,x))-mu_1*(kappa_rmpi - x*floor(B*To))) ; %a= value , b=location
    end
muu(x)=mu_1(b);

end


% Recalculate

x=1:R_max
Mkk=zeros(1,length(x));

for x=1:R_max
   
    Mk1=0;
    
    for k=x:2*x 
        
if System_switch==1
       Mk1=Mk1 + exp(mu*k)*nchoosek(x,k-x)*ps_MCDR^(k-x)*(1-ps_MCDR)^(x-(k-x)); % MWC
else
           Mk1=Mk1 + exp(mu*k)*nchoosek(x,k-x)*ps_RMPI^(k-x)*(1-ps_RMPI)^(x-(k-x)); % RMPI
end

    end
   Mk(x)=Mk1;
    
end



% Chernoff bound

if System_switch==1
x=1:R_max;
PSuc_R_MCDR=zeros(1,length(x));

for x=1:R_max;
PSuc_R_MCDR(x)=1-exp(-muu(x)*kappa)*Mk(x);
end

else
    x=1:R_max;
PSuc_R_RMPI=zeros(1,length(x));

for x=1:R_max;
PSuc_R_RMPI(x)=1-exp(-muu(x)*(kappa_rmpi - x*floor(B*To)))*Mk(x);
end

end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% RMPI %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% Sig_index=[1:R_max];
% kappa_RMPI=kappa*N_block;
% mu=0:0.01:10;
% 
% Mk_r=zeros(length(mu),length(x));
% 
% 
% %
% mu_index=0;
% 
% for mu=0:0.01:10         % if reparametering, i should remanage the following parameter (mu_1)
% mu_index=mu_index+1;
% 
% index=0;
% for x=Sig_index*(floor(B*To)) % num of unsplited
%    index=index+1;
%    
%     Mk2=0;
%     ps_RMPI=B*To-floor(B*To);
%     
%     
%     for k=x:x+Sig_index(index) 
% 
%        Mk2=Mk2 + exp(mu*k)*nchoosek(x,k-x)*ps_RMPI^(k-x)*(1-ps_RMPI)^(x-(k-x));
%        
%     end
%    Mk_r(mu_index,index)=Mk2;
%     
% end
% 
% end
% 
% 
% % find optimal mu
% 
% muu=zeros(1,R_max);
% mu_1=(0:0.01:10)';
% 
% 
% for x=1:R_max
%       
%     
% [a, b]= min( log(Mk_r(:,x))-mu_1*kappa_RMPI ) ; %a= value , b=location
% 
% muu(x)=mu_1(b);
% 
% end
% 
% 
% % Recalculate
% 
% x=1:R_max
% Mkk=zeros(1,length(x));
% 
% for x=[1:R_max]*(floor(B*To))
%    
%     Mk2=0;
%     
%     for k=x:2*x 
% 
%        Mk2=Mk2 + exp(muu(x)*k)*nchoosek(x,k-x)*ps_RMPI^(k-x)*(1-ps_RMPI)^(x-(k-x));
%        
%     end
%    Mk_rm(x)=Mk2;
%     
% end
% 
% 
% Chernoff bound
% 
% 
% x=1:R_max;
% PSuc_R_RMPI=zeros(1,length(x));
% 
% for x=1:R_max;
% PSuc_R_RMPI(x)=1-Mk_rm(x);
% 
% end
% 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%

if W_bpf>f_NYQ/2
    error('Too large W_bpf')
end


 %RSSR
 
PSuc_R_RSSR=(2*(W_bpf-B)/(f_NYQ-2*B)).^R_axis;

for x=1:R_max
 if PSuc_R_MCDR(x)<0
     PSuc_R_MCDR(x)=0;
 end
 if PSuc_R_RMPI(x)<0
     PSuc_R_RMPI(x)=0;
 end
end

ylim([0 1])
% plot(R_axis,PSuc_R_MCDR)
hold on
plot(R_axis,PSuc_R_RSSR')
hold on
% plot(R_axis,PSuc_R_RMPI)

legend('MWC','Lower bound of MWC', 'RSSR', 'RMPI')
ylabel('Probability of successful sampling')
xlabel('The number of received radar signals')
xlim([1 R_max])
ylim([0 1])
grid on
% title(strcat('\kappa_{MCDR}=',num2str(kappa), ', f_{max}=', num2str(f_NYQ/2/10^9),' [GHz]',', B=', num2str(B/10^6), ' [MHz]',', f_p=',num2str(fp/10^6),' [MHz]',', W_{BPF}=', num2str(W_bpf/10^9),' [GHz]'))