function [iter, Supp] = RunOMP_Unnormalized(Y,Aset,NumIters,ResThreshold, SymmetricSupport, JSM2, half_sampling, OMP_SubSampling,To,B,k_)

[mY,nY] = size(Y);

if OMP_SubSampling==true
    FreqRes=1/To;
    Interval=max(floor(B/2/FreqRes),1);
    SubSamplingIndices=[1:Interval:k_-1, k_:Interval:nY-1 nY];
end

if JSM2==true
    [mA,nA] = size(Aset{1});
    A_normedSet=cell(size(Aset));
    for Freq=1:nY
        A=Aset{Freq};
        NormACols = sqrt(diag(A'*A));
        A_normed=A*diag(1./double(NormACols));
        A_normedSet(Freq)={A_normed};
    end
else
    A=Aset;
    [mA, nA]= size(A);
    NormACols = sqrt(diag(A'*A));
    A_normed=A*diag(1./double(NormACols));
end
residual = Y;
Supp = [];
iter = 0;
resnorm = norm(Y);

% 
% if half_sampling==1
%     
%     nA=2*nA-1;
% 
% end





while ( (iter < NumIters)  &&  (resnorm > ResThreshold))
    % Matching step
    if JSM2==true
        Z_1=zeros(nA,nY);
        for Freq=1:nY
            Z_1(:,Freq) = A_normedSet{Freq}'*residual(:,Freq);
        end
    else
        if OMP_SubSampling==true
            residual_s=residual(:,SubSamplingIndices);
            Z_1=A_normed'*residual_s;
        else
            Z_1=A_normed'*residual;
        end
   end
    Z = sum(abs(Z_1).^2,2);   
    [maxVal, maxPos] = max(Z);
    BestLoc = maxPos(1);
    % Update support
    Supp = [Supp BestLoc];
    if (SymmetricSupport == true)
        SymmetricLoc =  (nA+1-BestLoc);
        if (BestLoc ~= SymmetricLoc)
%             Supp = union(Supp, [max(BestLoc-1,1) min(BestLoc+1,nA) SymmetricLoc max(SymmetricLoc-1,1) min(SymmetricLoc+1,nA)]);
          Supp=[Supp SymmetricLoc];
        end
        
    else
        
        
    end
    
    % Project residual
    if JSM2==true
        for Freq=1:nY
            A_el=Aset{Freq};
            As = A_el(:,Supp);
            solution_el = As*pinv(As)*Y(:,Freq);
            residual(:,Freq) = Y(:,Freq)-solution_el;
        end
    else
        As=A(:,Supp);
        solution=As*pinv(As)*Y;
        residual=Y-solution;
    end
    iter = iter+1;
end